/*
 * 
 *  dynamic linker command file
 *  generated: Mon Mar 25 17:56:31 2002

 *  kernel   : legOS
 *  app start: 0xb538
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x3538
  ram   : o = 0xb538, l = 0x49c4
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _systime_handler = 0x00cc ;
    _systime_init = 0x015e ;
    _systime_shutdown = 0x0196 ;
    _sem_event_wait = 0x01a0 ;
    _sem_wait = 0x01b8 ;
    _sem_trywait = 0x01e0 ;
    _sem_post = 0x01f8 ;
    _delay = 0x0208 ;
    _cputc_native = 0x0222 ;
    _cputc_native_0 = 0x0254 ;
    _cputc_native_1 = 0x028c ;
    _cputc_native_2 = 0x02c4 ;
    _cputc_native_3 = 0x0300 ;
    _cputc_native_4 = 0x033c ;
    _cputc_native_5 = 0x0378 ;
    _cputw = 0x0384 ;
    _cputs = 0x03c8 ;
    _cls = 0x0410 ;
    _lcd_number = 0x041a ;
    _lcd_refresh_next_byte = 0x04ac ;
    _lcd_refresh_next_byte_core = 0x04c0 ;
    _lcd_refresh = 0x0514 ;
    _lcd_power_on = 0x0544 ;
    _lcd_power_off = 0x0556 ;
    _lcd_init = 0x0572 ;
    _rx_handler = 0x05ba ;
    _rx_core = 0x05ce ;
    _rxerror_handler = 0x0644 ;
    _rxerror_core = 0x0658 ;
    _txend_handler = 0x06a2 ;
    _txend_core = 0x06b6 ;
    _tx_handler = 0x06c4 ;
    _tx_core = 0x06d8 ;
    _lnp_logical_shutdown = 0x0700 ;
    _lnp_logical_init = 0x0720 ;
    _lnp_logical_write = 0x07c6 ;
    _lnp_integrity_write = 0x0876 ;
    _lnp_addressing_write = 0x08bc ;
    _lnp_receive_packet = 0x0918 ;
    _lnp_integrity_byte = 0x09b6 ;
    _lnp_integrity_reset = 0x0a74 ;
    _lnp_integrity_reset_core = 0x0a88 ;
    _lnp_timeout_reset = 0x0ab4 ;
    _lnp_timeout_reset_core = 0x0ac8 ;
    _lnp_init = 0x0ad2 ;
    _lnp_integrity_active = 0x0af2 ;
    _lnp_timeout_set = 0x0afe ;
    _vis_handler = 0x0b08 ;
    _vis_core = 0x0b1c ;
    _get_battery_mv = 0x0b44 ;
    _battery_refresh = 0x0b72 ;
    _battery_refresh_core = 0x0b86 ;
    _shutoff_restart = 0x0bb0 ;
    _shutoff_init = 0x0bc0 ;
    _autoshutoff_check = 0x0bcc ;
    _autoshutoff_check_core = 0x0be0 ;
    _dkey_handler = 0x0c00 ;
    _dkey_pressed = 0x0c3e ;
    _dkey_released = 0x0c60 ;
    _getchar = 0x0c80 ;
    _dm_handler = 0x0cb2 ;
    _dm_init = 0x0cf0 ;
    _dm_shutdown = 0x0cf4 ;
    _motor_a_dir = 0x0d18 ;
    _motor_b_dir = 0x0d58 ;
    _motor_c_dir = 0x0d9c ;
    _ds_rotation_set = 0x0de4 ;
    _ds_rotation_handler = 0x0e3c ;
    _ds_init = 0x0f30 ;
    _ds_shutdown = 0x0f66 ;
    _uip_init = 0x0f80 ;
    _uip_listen = 0x0fe6 ;
    _uip_periodic = 0x1012 ;
    _uip_process = 0x1030 ;
    _uip_add_rcv_nxt = 0x1996 ;
    _uip_add_ack_nxt = 0x19c0 ;
    _uip_ipchksum = 0x1a82 ;
    _uip_tcpchksum = 0x1a90 ;
    _httpd_init = 0x1b88 ;
    _httpd = 0x1b96 ;
    _fs_open = 0x1efc ;
    _fs_init = 0x1f3a ;
    _prgmKeyCheck = 0x1f3c ;
    _prepareData = 0x1f50 ;
    _packet_handler = 0x1fa2 ;
    _memset = 0x21f8 ;
    _memcpy = 0x2206 ;
    ___mulsi3 = 0x2218 ;
    ___divsi3 = 0x2234 ;
    _hex_display_codes = 0x2272 ;
    _ascii_display_codes = 0x2282 ;
    _dm_a_pattern = 0x2314 ;
    _dm_b_pattern = 0x2318 ;
    _dm_c_pattern = 0x231c ;
    _file_index_html = 0x2dee ;
    _file_sensors_footer_plain = 0x2df6 ;
    _file_sensors_header_html = 0x2dfe ;
    _file_cgi_sensors = 0x2e06 ;
    _file_cgi_mforw = 0x2e0e ;
    _file_cgi_mback = 0x2e16 ;
    _file_cgi_mstop = 0x2e1e ;
    _file_motors_html = 0x2e26 ;
    _file_copyright_html = 0x2e2e ;
    _file_control_html = 0x2e36 ;
    _file_about_html = 0x2e3e ;
    _firmware_string = 0x2e70 ;
    _etext = 0x2e70 ;
    _lcd_refresh_period = 0x2e72 ;
    _lnp_timeout = 0x2e74 ;
    _vis_refresh_counter = 0x2e76 ;
    _vis_refresh_period = 0x2e77 ;
    _battery_refresh_counter = 0x2e78 ;
    _battery_refresh_period = 0x2e7a ;
    _auto_shutoff_counter = 0x2e7c ;
    _auto_shutoff_period = 0x2e7e ;
    _auto_shutoff_secs = 0x2e80 ;
    _auto_shutoff_elapsed = 0x2e82 ;
    _idle_powerdown = 0x2e84 ;
    _cgitab = 0x2e86 ;
    __edata = 0x2e8a ;
    _bss_start = 0x2e90 ;
    _sys_time = 0x31a4 ;
    _lcd_byte_counter = 0x31a8 ;
    _lcd_refresh_counter = 0x31a9 ;
    _tx_state = 0x31aa ;
    _lnp_integrity_handler = 0x31b0 ;
    _lnp_timeout_counter = 0x31b2 ;
    _lnp_addressing_handler = 0x31c0 ;
    _lnp_integrity_state = 0x33a0 ;
    _dkey_timer = 0x33a2 ;
    _dkey = 0x33a3 ;
    _dkey_multi = 0x33a4 ;
    _dm_a = 0x33a8 ;
    _dm_b = 0x33ac ;
    _dm_c = 0x33b0 ;
    _ds_rotation = 0x33b8 ;
    _ds_channel = 0x33b9 ;
    _ds_rotations = 0x33c0 ;
    _ds_activation = 0x33c6 ;
    _uip_conn = 0x33d0 ;
    _uip_len = 0x33d2 ;
    _uip_listenports = 0x33d4 ;
    _uip_buf = 0x33e0 ;
    _uip_ipaddr = 0x34a8 ;
    _uip_flags = 0x34ac ;
    _uip_conns = 0x34b0 ;
    _uip_appdata = 0x3530 ;
    _hs = 0x3532 ;
    _done = 0x3534 ;
    _end = 0x3536 ;
    _mm_start = 0x3536 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
